

#ifndef MASTERSCREEN_H
#define MASTERSCREEN_H

class RGB_Sprite;

#define     DATA_PORT       PORTB
#define     DATA_PIN        PB0

#define     CLK_PORT        PORTD
#define     CLK_PIN         PD5

#define     LATCH_PORT      PORTD
#define     LATCH_PIN       PD7

#define     EN_PIN          PD3
#define     RESET_PIN       PD6


#define DATA                8
#define DATA_OUTPUT_ENABLE  3
#define LATCH               7
#define CLOCK               5
#define RESET               6

typedef unsigned char byte;

class masterScreen
{
  public:
    void createScreen();
    void printMasterScreen();
    void updateMasterScreen(RGB_Sprite sprite_object);
    void clearSprite(RGB_Sprite sprite_object);
    void clearMasterScreen();

    byte getScreenValue(byte row, byte col);
    void modifyScreen(byte row, byte col, byte value);
    void screen_display_col(byte col);  //approx 132us to run
    bool updateFlag;
    void updateScreen(byte num_sprites, RGB_Sprite sprite_obj[]);

  private:

    void _shift_init();
    void _shift_byte_in(byte b);
    void _shift_in(byte red, byte green, byte blue, byte anode);
    static void _screen_timer_init();
   // void screen_display_col(byte col);



    void init();
    \
    byte _masterScreen[8][8];

};

#endif
// MASTERSCREEN_H
